## polyorb 2.11~20140418

=== contrib/local_sockets/test/Makefile ===
ADB =test_client_server.adb  
OADB=test_client_server_ork.adb  
EXE= $(patsubst %.adb,%, $(ADB))
ORK_EXE= $(patsubst %.adb,%.ork, $(OADB))


#srcdir= path/to/polyorb/src
#ork_srcdir= path/to/polyorb_compiled_for_ORK/src

#	Need to precise the PolyORB src directory path (put it in srcdir) 
#	ork_srcdir is used if you want to compile for ORK, compile PolyORB
#	for ORK platforms and initialize this variable with the src 
#	directory of PolyORB compiled for ORK


giopdir=$(srcdir)/giop
corbadir=$(srcdir)/corba

ork_giopdir=$(ork_srcdir)/giop
ork_corbadir=$(ork_srcdir)/corba

GNATFLAGS = -g -O2 -gnatfy -gnatoa -fstack-check -gnatwa #-a

GNATMAKE = gnatmake
ORK_GNATMAKE = i386-ork-gnatmake

INCLUDE = -I../protocol -I$(srcdir) -I$(giopdir) -I$(corbadir) \
-L$(srcdir)/.libs -L$(giopdir)/.libs -L$(corbadir)/.libs

ORK_INCLUDE =  -I../protocol \
-I$(ork_srcdir) -I$(ork_giopdir)  -I$(ork_corbadir) \
-L$(ork_srcdir)/.libs -L$(ork_giopdir)/.libs -L$(ork_corbadir)/.libs


LARGS=
ORK_LARGS = -largs -k -specs ork_specs 

CMD = ${GNATMAKE} ${GNATFLAGS} ${INCLUDE}


all: #compile ork_compile
	@-echo "make compile     : Compile for Linux"
	@-echo "make ork_compile : Compile for ORK"	

compile :${ADB} echo-skel.ads
	${CMD} ${ADB} ${LARGS}

ork_compile : echo-skel.ads ${ORK_EXE} 

%.ork:%.adb
	${ORK_GNATMAKE} -o $@ $< ${GNATFLAGS} ${ORK_INCLUDE} ${ORK_LARGS} 

echo-skel.ads : echo.idl
	      idlac echo.idl

force:	
	
clean:
	@-rm -f *.ali *.o *~ b~* *.gz *helper* *skel* *echo.ad* GNAT*

distclean: clean
	@-rm -f $(EXE) ${ORK_EXE}

=== contrib/local_sockets/test_sockets/Makefile ===
ADB = test_ls.adb
include Makefile.common

=== testsuite/idls/echo/Makefile ===
SHELL = /bin/sh
GNATCHOP = gnatchop
GNATFLAGS = -g -O2 -gnatfy -gnatwae -gnatpn
GNATMAKE = gnatmake

all: server client

force:

server: force echo-skel.ads 
	$(GNATMAKE)  server.adb `polyorb-config`

client: force echo-skel.ads
	$(GNATMAKE)  client.adb `polyorb-config`

echo-skel.ads: echo.idl 
	iac -ada echo.idl > iac.ada 
	$(GNATCHOP) -w iac.ada

clean: 
	@-rm -f *.o *.ali *ir_info* 
	@-rm -f client server *skel* *helper* *idl_file* 
	@-rm -f echo.ad* iac.ada  GNAT* *~

=== testsuite/idls/harness/Makefile ===
SHELL = /bin/sh
GNATCHOP = gnatchop
GNATFLAGS = -g -O2 -gnatfy -gnatwae -gnatpn
GNATMAKE = gnatmake

all: servers client

force:

servers: force harness-skel.ads 
	$(GNATMAKE)  server*.adb -I../../../../perforce/cos/naming/ `polyorb-config`

client: force harness-skel.ads
	$(GNATMAKE)  client.adb -I../../../../perforce/cos/naming/ `polyorb-config`

harness-skel.ads: harness.idl 
	iac -ada harness.idl > iac.ada 
	$(GNATCHOP) -w iac.ada

clean: 
	@-rm -f *.o *.ali *ir_info* 
	@-rm -f client server_no_tasking *skel* *helper* *idl_file* 
	@-rm -f harness.ad* iac.ada  GNAT* *~
	@-rm -f server*_tasking2 s*request s*pool s*session s*lf s*hahs

=== testsuite/corba/interop/cpp/omniORB/Makefile ===
#######################################################################
# Shell setup

DEL = rm -f

#######################################################################
# C/C++ compiler to use

CXX = g++ -D__USE_OMNIORB__
LD  = g++

#######################################################################
# Setup for omniORB 4.1.2

# OMNIORB_PATH    = <path_to_omniORB_install_dir>
OMNIORB_PATH    = /usr
OMNIORB_BIN     = $(OMNIORB_PATH)/bin
OMNIORB_INC     = $(OMNIORB_PATH)/include 
OMNIORB_LIBPATH = $(OMNIORB_PATH)/lib
OMNIORB_LIB     = -lomniORB4 -lomnithread -lomniDynamic4

# IDL Compiler setup
IDL = $(OMNIORB_BIN)/omniidl
IDL_FLAGS = -bcxx

#######################################################################
# Makefile configured for omniORB 4.0.6

CXXFLAGS = -c -Wall -I$(OMNIORB_INC) -g	-I./
LD_FLAGS = -g
LIBS = -L$(OMNIORB_LIBPATH) $(OMNIORB_LIB) -pthread

PROG= all_types_dynclient all_types_dynserver all_types_client all_types_server all_functions_client

all: $(PROG)

all_types_dynserver: all_types_dynserver.o
	$(LD) all_types_dynserver.o $(LD_FLAGS) $(LIBS) -o all_types_dynserver

all_types_dynclient: all_types_dynclient.o
	$(LD) all_types_dynclient.o $(LD_FLAGS) $(LIBS) -o all_types_dynclient

all_types_dynclient.o: ../common/all_types_dynclient.cc
	$(CXX) $(CXXFLAGS) ../common/all_types_dynclient.cc

all_types_dynserver.o: ../common/all_types_dynserver.cc
	$(CXX) $(CXXFLAGS) ../common/all_types_dynserver.cc

all_functions_client: all_functionsSK.o all_functions_client.o 
	$(LD) all_functions_client.o all_functionsSK.o $(LD_FLAGS) $(LIBS) -o all_functions_client

all_functions_client.o: ../common/all_functions_client.cc
	$(CXX) $(CXXFLAGS) ../common/all_functions_client.cc

all_functionsSK.o: all_functions.hh
	$(CXX) $(CXXFLAGS) all_functionsSK.cc

all_functions.hh: ../../../../../examples/corba/all_functions/all_functions.idl
	$(IDL) $(IDL_FLAGS) ../../../../../examples/corba/all_functions/all_functions.idl

all_types_client: all_types_client.o all_typesSK.o
	$(LD) all_types_client.o all_typesSK.o $(LD_FLAGS) $(LIBS) -o all_types_client

all_types_server: all_types_server.o all_typesSK.o
	$(LD) all_types_server.o all_typesSK.o $(LD_FLAGS) $(LIBS) -o all_types_server

all_types_client.o: ../common/all_types_client.cc all_types.hh all_typesSK.cc
	$(CXX) $(CXXFLAGS) ../common/all_types_client.cc 

all_types_server.o: all_types.hh all_typesSK.cc ../common/all_types_server.cc ../common/all_types_imp.cc
	$(CXX) $(CXXFLAGS) ../common/all_types_server.cc

all_typesSK.o: all_types.hh all_typesSK.cc
	$(CXX) $(CXXFLAGS) all_typesSK.cc

all_types.hh all_typesSK.cc: ../../../../../examples/corba/all_types/all_types.idl
	$(IDL) $(IDL_FLAGS) ../../../../../examples/corba/all_types/all_types.idl

clean:
	$(DEL) *.o *~
	$(DEL) $(PROG)

distclean: clean
	$(DEL) all_types.hh all_typesSK.cc all_functions.hh all_functionsSK.cc

=== testsuite/corba/interop/java/Jonathan/Makefile ===
#######################################################################
# $Id$

#######################################################################
# Shell setup

DEL   = rm -rf

#######################################################################
# Java SDK and RE
# (configured for Blackdown Java on Linux, v 1.4.1-01)

JAVA  = java
JAVAC = javac

CLASSPATH_FLAG = -classpath
CLASSPATH      = $(ORB_CLASSPATH):.:./..
OPTIONS        = -d .

COMPILE = $(JAVAC) $(CLASSPATH_FLAG) $(CLASSPATH) $(OPTIONS)
RUN     = $(JAVA)  $(CLASSPATH_FLAG) $(CLASSPATH) $(ORB_OPTIONS)

#######################################################################
# Configuration for Jonathan 3.0 alpha 10

#JONATHAN_JARPATH = <path_to_Jonathan_library>
JONATHAN_JARPATH = $HOME/local/Jonathan_3_0_a10/libs

JONATHAN         = $(JONATHAN_JARPATH)/Jonathan_3_0_a10.jar
KILIM            = $(JONATHAN_JARPATH)/kilim.jar
KILIM_TOOLS      = $(JONATHAN_JARPATH)/kilim-tools.jar
NANOXML          = $(JONATHAN_JARPATH)/nanoxml-lite-2.2.1.jar

JONATHAN_CLASSPATH =$(JONATHAN):$(KILIM):$(KILIM_TOOLS):$(NANOXML)

JONATHAN_OPTION = \
	-Dorg.omg.CORBA.ORBClass=org.objectweb.david.libs.binding.orbs.iiop.IIOPORB \
	-Dorg.omg.CORBA.ORBSingletonClass=org.objectweb.david.libs.binding.orbs.ORBSingletonClass \
	-Ddavid.naming.default_method=2 \
	-Ddavid.naming.default_file=ns.ior

JONATHAN_GENERATED_FILES = ./idl

JONATHAN_IDL = $(RUN) org.objectweb.david.tools.idlcompiler.Idl2Java -p idl -poa

#######################################################################
# Generic rules

.SUFFIXES:
.SUFFIXES:      .java .class  
.SUFFIXES:      .idl  

.java.class:
	$(COMPILE) $<

.idl:
	$(IDL) $<

#######################################################################
# Define the ORB for which this makefile is configured

ORB_CLASSPATH   = $(JONATHAN_CLASSPATH)
ORB_OPTIONS     = $(JONATHAN_OPTIONS)
GENERATED_FILES = $(JONATHAN_GENERATED_FILES)
IDL             = $(JONATHAN_IDL)

#######################################################################

IDL_FILE    = all_types.idl
CLASS_FILES = DynSkeleton.class DynServer.class \
	DynClient.class

all: class

idl : $(IDL_FILE:.idl=)
class : $(CLASS_FILES:.java=.class)
DynClient.class: ../common/DynClient.java
		 $(COMPILE) ../common/DynClient.java

DynServer.class: ../common/DynServer.java
		 $(COMPILE) ../common/DynServer.java

DynSkeleton.class: ../common/DynSkeleton.java
		 $(COMPILE) ../common/DynSkeleton.java

run_server : Server.class
	$(RUN) Server

run_client : Client.class
	$(RUN) Client

run_dynserver : DynServer.class
	$(RUN) DynServer

run_dynclient : DynClient.class
	$(RUN) DynClient

clean:
	$(DEL) *~ *\# IOR
	$(DEL) *.class

veryclean: clean
	$(DEL) $(GENERATED_FILES)

=== testsuite/corba/interop/java/OpenORB/Makefile ===
#######################################################################
# $Id$

#######################################################################
# Shell setup

DEL   = rm -rf

#######################################################################
# Java SDK and RE
# (configured for Blackdown Java on Linux, v 1.4.1-01)

JAVA  = java
JAVAC = javac

CLASSPATH_FLAG = -classpath
CLASSPATH      = $(ORB_CLASSPATH):.:./..:./../common
OPTIONS        = -d .

COMPILE = $(JAVAC) $(CLASSPATH_FLAG) $(CLASSPATH) $(OPTIONS)
RUN     = $(JAVA)  $(CLASSPATH_FLAG) $(CLASSPATH) $(ORB_OPTIONS)

#######################################################################
# Configuration for OpenORB 1.3.0

#OPENORB_JARPATH = <path_to_OpenORB_library>
OPENORB_JARPATH = $HOME/local/OpenORB-1.3.0/lib
OPENORB           = $(OPENORB_JARPATH)/openorb-1.3.0.jar
OPENORB_TOOLS     = $(OPENORB_JARPATH)/openorb_tools-1.3.0.jar
LOGKIT            = $(OPENORB_JARPATH)/logkit.jar
AVALON            = $(OPENORB_JARPATH)/avalon-framework.jar

OPENORB_CLASSPATH = $(OPENORB):$(OPENORB_TOOLS):$(LOGKIT):$(AVALON):$(GENERATED_FILES)

OPENORB_OPTIONS   =

OPENORB_GENERATED_FILES = ./generated

OPENORB_IDL       = $(RUN) org.openorb.compiler.IdlCompiler

#######################################################################
# Generic rules

.SUFFIXES:
.SUFFIXES:      .java .class  
.SUFFIXES:      .idl  

.java.class:
	$(COMPILE) $<

.idl:
	$(IDL) $<

#######################################################################
# Define the ORB for which this makefile is configured

# For OpenORB 1.3.0
ORB_CLASSPATH   = $(OPENORB_CLASSPATH)
ORB_OPTIONS     = $(OPENORB_OPTIONS)
GENERATED_FILES = $(OPENORB_GENERATED_FILES)
IDL             = $(OPENORB_IDL)

#######################################################################

CLASS_FILES = DynSkeleton.class DynServer.class \
	DynClient.class

all: class

idl : $(IDL_FILE:.idl=)

DynClient.class: ../common/DynClient.java
		 $(COMPILE) ../common/DynClient.java

DynServer.class: ../common/DynServer.java
		 $(COMPILE) ../common/DynServer.java

DynSkeleton.class: ../common/DynSkeleton.java
		 $(COMPILE) ../common/DynSkeleton.java

class : $(CLASS_FILES:.java=.class)

run_dynserver : DynServer.class
	$(RUN) DynServer

run_dynclient : DynClient.class
	$(RUN) DynClient

clean:
	$(DEL) *~ *\# IOR
	$(DEL) *.class

veryclean: clean
	$(DEL) $(GENERATED_FILES)

=== debian/changelog ===
polyorb (2.11~20140418-5) unstable; urgency=medium

  * Swith to debhelper 11. Drop autotools add-on, now activated by default.
  * Standards-version 4.1.4.
  * Style details: VCS-Mtn URI format, typos.

  [ Adrian Bunk <bunk@debian.org> ]
  * fig2dev327.patch fixes a .fig image and closes: #896575.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 23 Apr 2018 12:48:47 +0200

polyorb (2.11~20140418-4) unstable; urgency=medium

  * Add me as Uploader.
  * Rebuild with gnat-7.
    - Rename -dev and runtime packages with new ALI and SO versions.
     -Stop Breaking/Replacing previous -dev built with another compiler.
  * Update Build-Dependencies: obsolete (dh-ada-library),
    renamed (texlive-generic, fig2dev) or new (texlive-latex).
  * Reorganize internal dependencies according to policy.
    -bin and -dev Suggest: -doc
    -doc stops Recommending: -dev.
    -dev Depends: gnat per Ada Debian policy.
  * Allow -doc to satisfy Multi-Arch same dependencies.
  * Simplify debian/rules and reduce divergence with upstream.
  * Debhelper 10. Remove explicit policy targets and -dbg package.
    Separate autoconf and configure steps.
  * Enable hardening flags.
  * Add minimal runtime test.
  * Standard-Versions: 4.1.0. HTTPS copyright format URL.
    Allow DEB_BUILD_OPTIONS=nodoc.
  * Fix duplicate licence in copyright.
  * Remove bug-561121.patch, old work-around for sparc.
  * Gcc-7 does not need an executable stack anymore, drop lintian override.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 24 Aug 2017 18:50:17 +0200

polyorb (2.11~20140418-3.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Svante Signell ]
  * debian/patches/examples_corba_echo_echo-impl.adb.patch:
    - fix build failures with some Tex versions
      (Closes: #835966, Closes: #790664).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 03 Oct 2016 15:56:15 +0200

polyorb (2.11~20140418-3.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Svante Signell ]
  * build with gnat-6.  Closes: #831255.
  * Add patch to fix compilation due to missing include.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 19 Sep 2016 14:20:50 +0000

polyorb (2.11~20140418-3) unstable; urgency=low

  [Ludovic Brenta]
  * debian/rules: use --with autotools-dev in most targets forwarded to
    dh.  Reconfigure from the target override_dh_auto_configure, not from
    a separate target.  Patch from Matthias Klose.  Closes: #758743.
  [Xavier Grave]
  * Minor change to update last maintainer email address

 -- Xavier Grave <xavier.grave@csnsm.in2p3.fr>  Fri, 26 Sep 2014 11:09:29 +0200

polyorb (2.11~20140418-2) unstable; urgency=low

  * Upload to unstable.  Closes: #685564, #752890.
  * Rebuild with gnat-4.9 4.9.1.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue, 12 Aug 2014 13:12:57 +0200
  

polyorb (2.11~20140418-1) experimental; urgency=low

  [Ludovic Brenta]
  * New upstream version: Subversion revision 226475 with runtime library
    exception removed and documentation under pure GPL version 3 or later:
    com.adacore.polyorb.debian revision
    eaed77c62550dfe805490639563447f538ce0c4c. Closes: #701338, #709495.
  * debian/control (libpolyorb3-dev): break and replace libpolyorb2-dev.
  * debian/patches/fix-texi-syntax-error.patch: refresh.
  * debian/patches/remove-soap-in-tests.patch: refresh.
  * debian/patches/support-tilde-in-pathname.patch: new.
  * debian/patches/make-clean.patch: new.
  * debian/control (Architecture): any.  Closes: #568452.
  
  [Xavier Grave]
  * debian/control: Package renamings pursuant to Debian Policy for Ada:
    libpolyorb2-dev -> libpolyorb3-dev
    libpolyorb3     -> libpolyorb4
  * debian/control (Build-Depends): Migrate to gnat-4.9 from experimental.
  * debian/patches/polyorb-config-patch-for-gnatdist.patch:
    allow pcs_project1 use of "extends all" keyword, allowed by gnat-4.9.
  * debian/rules: generate one .gpr project file for each library instead of
    a single all-encompassing project file.
  * debian/rules: generate a new project file,
    /usr/share/ada/adainclude/polyorb_src.gpr, used by all other library-
    specific project files.

 -- Ludovic Brenta <lbrenta@debian.org>  Mon, 21 Apr 2014 08:17:24 +0200

=== debian/control ===
Source: polyorb
Section: net
Priority: optional
Maintainer: Xavier Grave <xavier.grave@csnsm.in2p3.fr>
Uploaders: Ludovic Brenta <lbrenta@debian.org>,
 Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.1),
 gnat, gnat-7,
# This line is parsed by debian/rules.
 python-gnatpython,
 automake, libtool, python
Build-Depends-Indep: ghostscript, texlive-formats-extra,
 texlive-latex-base,
 texlive-plain-generic, fig2dev, texinfo
Standards-Version: 4.1.4
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.polyorb
Vcs-Mtn: mtn://www.ada-france.org?org.debian.polyorb
Homepage: http://libre.adacore.com/libre/tools/polyorb/

Package: polyorb-servers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: polyorb-doc
Description: Multiple-personality middleware for Ada (servers)
 PolyORB provides a uniform solution to build distributed applications; relying
 either on industrial-strength middleware standards such as CORBA, the
 Distributed System Annex of Ada 95, distribution programming paradigms such as
 Web Services, Message Oriented Middleware (MOM), or to implement
 application-specific middleware.
 .
 This package provides various middleware servers needed to run a distributed
 application and tools to interact with these servers.

Package: libpolyorb4-dev
# This line is parsed by debian/rules.
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, g++,
 gnat, gnat-7, libpolyorb5 (= ${binary:Version})
# This line must match the gnat and and so versions.
Recommends: polyorb-servers (= ${binary:Version})
Suggests: polyorb-doc
Description: Multiple-personality middleware for Ada (development)
 PolyORB provides a uniform solution to build distributed applications; relying
 either on industrial-strength middleware standards such as CORBA, the
 Distributed System Annex of Ada 95, distribution programming paradigms such as
 Web Services, Message Oriented Middleware (MOM), or to implement
 application-specific middleware.
 .
 This package provides the development files and utilities necessary to develop
 distributed applications using PolyORB.
 .
 Distributed applications will also require the polyorb-servers package but not
 necessarily on the same machine.

Package: libpolyorb5
# This line is parsed by debian/rules.
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Recommends: polyorb-servers (= ${binary:Version})
Description: Multiple-personality middleware for Ada
 PolyORB provides a uniform solution to build distributed applications; relying
 either on industrial-strength middleware standards such as CORBA, the
 Distributed System Annex of Ada 95, distribution programming paradigms such as
 Web Services, Message Oriented Middleware (MOM), or to implement
 application-specific middleware.
 .
 Distributed applications will also require the polyorb-servers package but not
 necessarily on the same machine.

Package: polyorb-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Multiple-personality middleware for Ada (documentation)
 PolyORB provides a uniform solution to build distributed applications; relying
 either on industrial-strength middleware standards such as CORBA, the
 Distributed System Annex of Ada 95, distribution programming paradigms such as
 Web Services, Message Oriented Middleware (MOM), or to implement
 application-specific middleware.
 .
 This package contains the documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/gnat_version:=\1/p;\
  s/^Package: libpolyorb\([0-9.]\+\)$$/soversion:=\1/p;\
  s/^Package: \(libpolyorb[0-9.]\+-dev\)$$/dev_pkg:=\1/p;\
  ' debian/control),$(eval $(line)))
lib_pkg := libpolyorb$(soversion)

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(gnat_version).mk

# Disable style checks, do not treat warnings as errors.
# There is no point in fixing new GCC warnings in old polyorb sources.
ADAFLAGS += -gnatyN -gnatwn

# Ignore timestamps, only consider checksums.
BUILDER_OPTIONS += -m

# A patch allows to select the library version.
BUILDER_OPTIONS += -XLibversion=$(soversion)

revision = a33ec96a70d7827d73ad160eceee81781cd529cd
orig_dir = polyorb.orig
orig_tgz = polyorb.orig.tar.gz
orig_pkg_dir = polyorb-$(DEB_VERSION_UPSTREAM).orig
orig_pkg_tgz = polyorb_$(DEB_VERSION_UPSTREAM).orig.tar.gz
branch   = com.adacore.polyorb.debian
mtndb    = polyorb.mtn
mtn_uri :=  mtn://www.ada-france.org?com.adacore.polyorb.debian

%:
	dh $@

# Ignore upstream tests, if any.
override_dh_auto_test:

.PHONY: get-orig-source
get-orig-source:
	if [ ! -e ../$(mtndb) ]; then \
		mtn -d../$(mtndb) db init; \
	fi; \
	TMPDIR=$$(mktemp --tmpdir --directory polyorb-get-orig-source-XXXXXXXXXX) && \
	mtn clone -d ../$(mtndb) $(mtn_uri) -k "" $$TMPDIR/$(orig_dir) && \
	chmod uog-x $$TMPDIR/$(orig_dir)/examples/corba/send/print.idl && \
	(cd $$TMPDIR && tar --create --gzip --exclude="_MTN" $(orig_dir)) > $(orig_tgz) ; \
	rm -rf $$TMPDIR
	@echo "The file $(orig_tgz) contains the latest Debian snapshot of upstream sources."

.PHONY: get-pkg-source
get-pkg-source:
	TMPDIR=$$(mktemp --tmpdir --directory polyorb-get-orig-source-XXXXXXXXXX) && \
	if [ ! -e ../$(mtndb) ]; then \
		mtn -d../$(mtndb) db init; \
	fi; \
	mtn -d../$(mtndb) -k "" pull $(mtn_uri); \
	mtn -d../$(mtndb) co -r$(revision) -b$(branch) $$TMPDIR/$(orig_pkg_dir) && \
	chmod uog-x $$TMPDIR/$(orig_pkg_dir)/examples/corba/send/print.idl && \
	(cd $$TMPDIR && tar --create --gzip --exclude="_MTN" $(orig_pkg_dir)) > $(orig_pkg_tgz)
	rm -rf $$TMPDIR
	@echo "The file $(orig_pkg_tgz) contains the pkg Debian of upstream sources."

.PHONY: override_dh_autoreconf
override_dh_autoreconf:
	support/reconfig

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
 # Using full DEB_VERSION would change ALI checksums on every upload.
	dh_auto_configure -- \
		PACKAGE_VERSION="Debian $(DEB_VERSION_UPSTREAM)" \
		ADA=gcc-$(gnat_version) \
		$(foreach v,ADAFLAGS CFLAGS CPPFLAGS LDFLAGS,'$(v)=$($(v))') \
		--enable-debug \
		--with-appli-perso="corba moma dsa" \
		--with-proto-perso="giop" \
		--with-corba-services="event ir naming notification time"

DIRS := static/src relocatable/src
$(DIRS):
	mkdir -p $@

# TODO: the log mentions config.adc, is it seen in src/ with the ad[bs] ??
# Symlinks create less timestamps problems than copies.
symlink_old := config.adc src.exclude
symlink_new := $(addprefix relocatable/src/,$(symlink_old)) \
               $(addprefix      static/src/,$(symlink_old))
$(symlink_new): | $(DIRS)
	ln -s ../../src/$(notdir $@) $@
# Copy part of Makefile.in buliding C sources, but compile twice.
relocatable/src/csupport.o : src/csupport.c  | relocatable/src
	gcc-$(gnat_version) -c -o $@ -Isrc $(CFLAGS) $(CPPFLAGS) -fPIC $<
static/src/csupport.o      : src/csupport.c  |      static/src
	gcc-$(gnat_version) -c -o $@ -Isrc $(CFLAGS) $(CPPFLAGS)       $<

.PHONY: override_dh_auto_build-arch
override_dh_auto_build-arch: $(symlink_new) \
                             relocatable/src/csupport.o static/src/csupport.o
	$(MAKE) \
	  LIBRARY_TYPE_OPTIONS=-XLIBRARY_TYPE=static \
	  EXTRA_GNATMAKE_FLAGS='$(BUILDER_OPTIONS)'
  # Pass LDFLAGS here because ./configure and Makefile.in ignore them.
  # They should only be useful during relocatable builds.
  # -largs acts when building executables.
  # LDFLAGS acts on projects thanks to add-version-to-libraries.patch.
  # -lpthread is only useful on some architecturse, but does not hurt
  # -with --as-needed.
	$(MAKE) \
	  LIBRARY_TYPE_OPTIONS=-XLIBRARY_TYPE=relocatable \
	  EXTRA_GNATMAKE_FLAGS='$(BUILDER_OPTIONS) "-XLDFLAGS=$(LDFLAGS) -lpthread" -largs $(LDFLAGS) -lpthread'

# if you really want to run the test suite
.PHONY: run_testsuite
run_testsuite:
	$(MAKE) examples

	rm -f testsuite/test_failed
	$(MAKE) testsuite

	cp -f src/moma/destinations.conf testsuite
	$(MAKE) run_tests

# remove .o .ali and exe in examples dir before doc inclusion
examples_to_delete := \
  polyorb/polyorb-test-thread_pool_poa \
  polyorb/polyorb-test-no_tasking_poa \
  polyorb/polyorb-test-thread_pool \
  polyorb/polyorb-test-no_tasking \
  corba/all_types/ir_server \
  corba/all_types/client_moma corba/all_types/dynclient \
  corba/all_types/server \
  corba/all_types/client \
  corba/echo/dynserver \
  corba/echo/dynclient \
  corba/echo/server corba/echo/client \
  corba/all_functions/dynclient \
  corba/all_functions/server \
  corba/all_functions/client \
  corba/thread_pool_tester/server corba/thread_pool_tester/client \
  corba/random/server \
  corba/random/client \
  corba/send/listener \
  corba/send/send
.PHONY: clean_examples_dir
clean_examples_dir:
	find examples -name "*.o" \
	           -o -name "*.ali" \
	           -o -name "b~*.ad[sb]" -delete
	rm -f $(addprefix examples/,$(examples_to_delete))

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))

.PHONY: override_dh_auto_build-indep
override_dh_auto_build-indep: | $(DIRS)
	$(MAKE) -C docs

.PHONY: override_dh_auto_install-indep
override_dh_auto_install-indep:clean_examples_dir
	$(MAKE) -C docs DESTDIR=$(CURDIR)/debian/tmp install

endif

.PHONY: override_dh_auto_clean
override_dh_auto_clean:clean_examples_dir
	[ ! -f docs/Makefile ] || $(MAKE) -C docs clean
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf static relocatable ali
	rm -f $(wildcard mkdir.flag b~*.ad[sb])

.PHONY: override_dh_auto_install-arch
override_dh_auto_install-arch:
	dh_auto_install

# These 2 lists will only be correct when dh calls the
# override_dh_install_target, but this is sufficient.
sublibs := $(patsubst debian/tmp/usr/lib/libpolyorb-%.so.$(soversion),%,\
           $(wildcard debian/tmp/usr/lib/libpolyorb-*.so.$(soversion)))
gpr_dir := debian/$(dev_pkg)/usr/share/ada/adainclude
gpr_template := debian/project_template
.PHONY: override_dh_install
override_dh_install:
	dh_install -p$(dev_pkg) \
	  usr/lib/polyorb/static/libpolyorb*.a \
	  usr/lib/$(DEB_HOST_MULTIARCH)
	dh_link -p$(dev_pkg) \
	  $(foreach l,libpolyorb $(addprefix libpolyorb-,$(sublibs)), \
	    usr/lib/$(DEB_HOST_MULTIARCH)/$(l).so.$(soversion) \
	    usr/lib/$(DEB_HOST_MULTIARCH)/$(l).so)
	mkdir -p $(gpr_dir)/polyorb
	cp debian/addon/polyorb_start.gpr $(gpr_dir)/polyorb.gpr
  # The list of libraries will be displayed here in the log.
	for sublib in $(sublibs); do \
	  nodash=`echo $$sublib | sed s/-/_/g` && \
	  sed $(gpr_template) \
	    -e s/PROJECT/polyorb_src_$$nodash/ \
	    -e s/VALUE_NAME/polyorb-$$sublib/ \
	    -e s/DEB_HOST_MULTIARCH/$(DEB_HOST_MULTIARCH)/ \
	    > $(gpr_dir)/polyorb/polyorb_src_$$nodash.gpr && \
	  echo "with \"polyorb/polyorb_src_$$nodash\";" >> $(gpr_dir)/polyorb.gpr ; \
	done
	cat debian/addon/polyorb.gpr >> $(gpr_dir)/polyorb.gpr
	sed $(gpr_template) \
	  -e s/PROJECT/polyorb_src/ \
	  -e s/VALUE_NAME/polyorb/ \
	  -e s/DEB_HOST_MULTIARCH/$(DEB_HOST_MULTIARCH)/ \
	  > $(gpr_dir)/polyorb/polyorb_src.gpr
	dh_install -p$(dev_pkg) -Xsoap -Xaws \
	  usr/include/polyorb/* \
	  usr/share/ada/adainclude/polyorb
	dh_install -p$(dev_pkg) \
	  usr/lib/polyorb/*.ali \
	  usr/lib/ada/adalib/polyorb
	dh_install -p$(dev_pkg) usr/bin/polyorb-config
	dh_install -p$(dev_pkg) usr/bin/iac
	dh_install -p$(dev_pkg) usr/bin/idlac
	dh_install -p$(dev_pkg) usr/bin/polyorb-config
	dh_install -p$(dev_pkg) usr/bin/po_gnatdist
	dh_install -p$(lib_pkg) \
	  usr/lib/libpolyorb*.so.$(soversion) \
	  usr/lib/$(DEB_HOST_MULTIARCH)
